<?php
// $Revision: 1.1.2.2 $
//  ------------------------------------------------------------------------ //
//  XooNIps - Neuroinformatics Base Platform System                          //
//  Copyright (C) 2005-2007 RIKEN, Japan All rights reserved.                //
//  http://xoonips.sourceforge.jp/                                           //
//  ------------------------------------------------------------------------ //
//  This program is free software; you can redistribute it and/or modify     //
//  it under the terms of the GNU General Public License as published by     //
//  the Free Software Foundation; either version 2 of the License, or        //
//  (at your option) any later version.                                      //
//                                                                           //
//  You may not change or alter any portion of this comment or credits       //
//  of supporting developers from this source code or any supporting         //
//  source code which is considered copyrighted (c) material of the          //
//  original comment or credit authors.                                      //
//                                                                           //
//  This program is distributed in the hope that it will be useful,          //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of           //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            //
//  GNU General Public License for more details.                             //
//                                                                           //
//  You should have received a copy of the GNU General Public License        //
//  along with this program; if not, write to the Free Software              //
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA //
//  ------------------------------------------------------------------------ //

if ( ! defined( 'XOOPS_ROOT_PATH' ) ) exit();

// title
$title = _AM_XOONIPS_SYSTEM_XOOPS_TITLE;
$description = _AM_XOONIPS_SYSTEM_XOOPS_DESC;

// breadcrumbs
$breadcrumbs = array(
  array( 'type' => 'top',  'label' => _AM_XOONIPS_TITLE, 'url' => $xoonips_admin['admin_url'].'/' ),
  array( 'type' => 'link',  'label' => _AM_XOONIPS_SYSTEM_TITLE, 'url' => $xoonips_admin['myfile_url'] ),
  array( 'type' => 'label', 'label' => $title, 'url' => '' )
);

// token ticket
require_once( '../class/base/gtickets.php' );
$ticket_area = 'xoonips_admin_system_xoops';
$token_ticket = $xoopsGTicket->getTicketHtml( __LINE__, 1800, $ticket_area );

// templates
require_once( '../class/base/pattemplate.class.php' );
$tmpl = new PatTemplate();
$tmpl->setBaseDir( 'templates' );
$tmpl->readTemplatesFromFile( 'system_xoops.tmpl.html' );

// logic
function &get_xoonips_unregistered_users() {
  global $xoopsDB;
  $users_handler =& xoonips_getormhandler( 'xoonips', 'xoops_users' );
  $xusers_handler =& xoonips_getormhandler( 'xoonips', 'users' );
  $criteria = new CriteriaElement();
//  $criteria = new Criteria( 'level', '0', '>' );
  $criteria->setSort( 'uname' );
  $users_objs =& $users_handler->getObjects( $criteria );
  $users = array();
  $evenodd = 'odd';
  foreach ( $users_objs as $users_obj ) {
    $uid = $users_obj->getVar( 'uid', 's' );
    $criteria = new Criteria( 'uid', $uid );
    if ( $xusers_handler->getCount( $criteria ) == 0 ) {
      $user['uid'] = $uid;
      $user['uname'] = $users_obj->getVar( 'uname', 's' );
      $user['name'] = $users_obj->getVar( 'name', 's' );
      $user['email'] = $users_obj->getVar( 'email', 's' );
      $user['uname_js'] = str_replace( '&#039;', '\\\'', $user['uname'] );
      $user['register'] = _AM_XOONIPS_LABEL_REGISTER;
      $user['evenodd'] = $evenodd;
      $users[] = $user;
      $evenodd = ( $evenodd == 'even' ) ? 'odd' : 'even';
    }
  }
  return $users;
}
$users = get_xoonips_unregistered_users();
$has_users = ( count( $users ) == 0 ) ? false : true;

// assign template variables
$tmpl->addVar( 'header', "TITLE", $title );
$tmpl->addVar( 'main', "TITLE", $title );
$tmpl->setAttribute( 'description', 'visibility', 'visible' );
$tmpl->addVar( 'description', "DESCRIPTION", $description );
$tmpl->setAttribute( 'breadcrumbs', 'visibility', 'visible' );
$tmpl->addRows( 'breadcrumbs_items', $breadcrumbs );
$tmpl->addVar( 'main', 'token_ticket', $token_ticket );
$tmpl->addVar( 'main', 'useradd_title', _AM_XOONIPS_SYSTEM_XOOPS_USERADD_TITLE );
$tmpl->addVar( 'main', 'useradd_desc', _AM_XOONIPS_SYSTEM_XOOPS_USERADD_DESC );
$tmpl->addVar( 'confirm_javascript', 'register_confirm', _AM_XOONIPS_MSG_REGISTER_CONFIRM );
$tmpl->addVar( 'confirm_javascript', 'uname', _AM_XOONIPS_LABEL_UNAME );
$tmpl->addVar( 'main', 'uname', _AM_XOONIPS_LABEL_UNAME );
$tmpl->addVar( 'main', 'name', _AM_XOONIPS_LABEL_NAME );
$tmpl->addVar( 'main', 'email', _AM_XOONIPS_LABEL_EMAIL );
$tmpl->addVar( 'main', 'action', _AM_XOONIPS_LABEL_ACTION );
$tmpl->addVar( 'users_empty', 'empty', _AM_XOONIPS_SYSTEM_XOOPS_USERADD_LABEL_EMPTY );
if ( $has_users ) {
  $tmpl->addRows( 'users', $users );
} else {
  $tmpl->setAttribute( 'users', 'visibility', 'hidden' );
  $tmpl->setAttribute( 'users_empty', 'visibility', 'visible' );
}

// display
xoops_cp_header();
$tmpl->displayParsedTemplate( 'main' );
xoops_cp_footer();

?>
