<?php
/* functions to display blocks and edit blocks.
 * $Revision: 1.52.4.19 $
 */

/*
	http://wiki.xoops.org/wakka.php?wakka=ModuleNamingConventions says:
		Always prefix with b_yourmoduledirname_ 
		Use only lowercase characters 
		Separate words with underscores (_)
*/

include_once XOOPS_ROOT_PATH.'/modules/xoonips/condefs.php';

// load xoonips login block
include dirname( __FILE__ ).'/xoonips_login.php';

// load xoonips user menu block
include dirname( __FILE__ ).'/xoonips_usermenu.php';

// load xoonips group admin menu block
include dirname( __FILE__ ).'/xoonips_groupadmin.php';

// load xoonips moderator menu block
include dirname( __FILE__ ).'/xoonips_moderator.php';

// load index tree block
include dirname( __FILE__ ).'/xoonips_tree.php';

// load quick search block
include dirname( __FILE__ ).'/xoonips_quicksearch.php';

// load item type list block
include dirname( __FILE__ ).'/xoonips_itemtypes.php';

// load user list block
include dirname( __FILE__ ).'/xoonips_userlist.php';

require_once XOOPS_ROOT_PATH . '/modules/xoonips/include/create_session.php';
require_once XOOPS_ROOT_PATH . '/modules/xoonips/include/lib.php';

/** display ranking block / new arrival block
 * @param new_flag  true: new arrival block. false: ranking block
 */

function xoonips_ranking_show( $new_flag ){
	global $xoopsUser;
	
	include_once XOOPS_ROOT_PATH . '/modules/xoonips/condefs.php';
	if ( xnp_load_init_create_session_silent() != 0 ) return false;
	$xnpsid = $_SESSION['XNPSID'];
	
	if ( !empty($xoopsUser) )
		$uid = $xoopsUser->getVar('uid');
	else
		$uid = UID_GUEST;
	
	if ( !public_item_target_user_all() && ( $uid == UID_GUEST || !xnp_is_activated($xnpsid, $uid) ) )
		return false;
	
	global $xoopsDB, $xoopsblock;
	$new_str = ( $new_flag ? '_new' : '' );
	
	//var_dump( $xoopsblock );
	//$side = $xoopsblock->getVar('side'); // this method does not work. $xoopsblock is NULL.
	global $block_arr;
	foreach ( $block_arr as $b ){
		if ( $b->getVar('show_func') == ( $new_flag ? 'b_xoonips_ranking_new_show' : 'b_xoonips_ranking_show' ) ){
			$side = $b->getVar( 'side' );
		}
	}
	
	if ( $side == XOOPS_SIDEBLOCK_LEFT      || 
	     $side == XOOPS_SIDEBLOCK_RIGHT     )
		$maxlen = 16;
	else if (
	     $side == XOOPS_CENTERBLOCK_LEFT    || 
	     $side == XOOPS_CENTERBLOCK_RIGHT   )
		$maxlen = 24;
	else
		$maxlen = 56;
	
	if ( RES_OK != xnp_get_config_value( "ranking${new_str}_num_rows", $num_rows     ) ) $num_rows     = 5;
	if ( RES_OK != xnp_get_config_value( "ranking${new_str}_visible" , $visible      ) ) $visible      = "1,1,1,1,1";
	if ( RES_OK != xnp_get_config_value( "ranking${new_str}_order"   , $order        ) ) $order        = "0,1,2,3,4";
	
	$visible = explode( ',', $visible );
	$order = explode( ',', $order );

	xnpRecalcRanking( true );
	
	$log_table               = $xoopsDB->prefix('xoonips_event_log');
	$viewed_item_table       = $xoopsDB->prefix('xoonips_ranking_viewed_item');
	$downloaded_item_table   = $xoopsDB->prefix('xoonips_ranking_downloaded_item');
	$contributing_user_table = $xoopsDB->prefix('xoonips_ranking_contributing_user');
	$searched_keyword_table  = $xoopsDB->prefix('xoonips_ranking_searched_keyword');
	$active_group_table      = $xoopsDB->prefix('xoonips_ranking_active_group');
	$new_item_table          = $xoopsDB->prefix('xoonips_ranking_new_item');
	$new_group_table         = $xoopsDB->prefix('xoonips_ranking_new_group');
	
	
	$item_perm_sql = " tb.item_id is not null and tx.open_level = " . OL_PUBLIC . " and txil.certify_state = " . CERTIFIED;
/*	if ( $uid == UID_GUEST ){
		$item_perm_sql = " tb.item_id is not null and tx.open_level = " . OL_PUBLIC . " and txil.certify_state = " . CERTIFIED;
	}
	else {
		$gids = array();
		$sess_id = session_id();
		$is_moderator = (int)xnp_is_moderator( $sess_id, $uid );
		$item_perm_sql = " tb.item_id is not null and ( $is_moderator or (tx.open_level = ".OL_PUBLIC." and txil.certify_state = ".CERTIFIED." or tx.open_level = ".OL_GROUP_ONLY." and tgul.uid=$uid and ( txil.certify_state = ".CERTIFIED." or tgul.is_admin ) ) ) "; // omit OL_PRIVATE-only items
	}
*/
	
	$item_joins = "
		left join ".$xoopsDB->prefix('xoonips_item_basic')." as tb on t.item_id=tb.item_id 
		left join ".$xoopsDB->prefix('xoonips_item_title')." as tt on t.item_id=tt.item_id 
		left join ".$xoopsDB->prefix('xoonips_index_item_link')." as txil on tb.item_id = txil.item_id
		left join ".$xoopsDB->prefix('xoonips_index')." as tx on tx.index_id = txil.index_id ";
//		left join ".$xoopsDB->prefix('xoonips_groups_users_link')." as tgul on tx.gid=tgul.gid";
	
	if ( $new_flag ){
		$sqls = array( 
			"select t.item_id, tt.title, date_format(timestamp,'%m/%d'),tb.doi from $new_item_table  as t $item_joins where tt.title_id=0 and $item_perm_sql group by t.item_id ",
			"select t.gid,     tg.gname, date_format(timestamp,'%m/%d') from $new_group_table as t left join ".$xoopsDB->prefix('xoonips_groups')." as tg on t.gid=tg.gid ",
		);
		$urls = array(
			XOOPS_URL . "/modules/xoonips/detail.php?%1\$s=%2\$s",
			XOOPS_URL . '/modules/xoonips/groups.php',
		);
		
		$ranking_names = array(
			_MB_XOONIPS_RANKING_NEW_ITEM,
			_MB_XOONIPS_RANKING_NEW_GROUP,
		);
		$orderby = " order by timestamp desc limit $num_rows";
	}
	else {
		$sqls = array( 
			"select distinct t.item_id, tt.title, count, tb.doi from $viewed_item_table as t     $item_joins where tt.title_id=0 and $item_perm_sql and count<>0 ",
			"select distinct t.item_id, tt.title, count, tb.doi from $downloaded_item_table as t $item_joins where tt.title_id=0 and $item_perm_sql and count<>0 ",
			"select distinct t.uid, tu.uname, count(*) as count from $contributing_user_table as t left join ".$xoopsDB->prefix('users')." as tu on t.uid=tu.uid where tu.uid is not null group by t.uid ",
			"select distinct t.keyword, t.keyword, count from $searched_keyword_table as t where count<>0 ",
			"select distinct t.gid, tg.gname, count from $active_group_table as t left join ".$xoopsDB->prefix('xoonips_groups')." as tg on tg.gid = t.gid where tg.gid is not null and count<>0 ",
		);
		$urls = array(
			XOOPS_URL . "/modules/xoonips/detail.php?%1\$s=%2\$s",
			XOOPS_URL . "/modules/xoonips/detail.php?%1\$s=%2\$s",
			XOOPS_URL . "/modules/xoonips/showusers.php?uid=%2\$s",
			XOOPS_URL . "/modules/xoonips/itemselect.php?op=quicksearch&amp;search_itemtype=all&amp;keyword=%2\$s",
			XOOPS_URL . "/modules/xoonips/groups.php",
		);
		
		$ranking_names = array(
			_MB_XOONIPS_RANKING_VIEWED_ITEM,
			_MB_XOONIPS_RANKING_DOWNLOADED_ITEM,
			_MB_XOONIPS_RANKING_CONTRIBUTING_USER,
			_MB_XOONIPS_RANKING_SEARCHED_KEYWORD,
			_MB_XOONIPS_RANKING_CONTRIBUTED_GROUP,
		);
		$orderby = " order by count desc limit $num_rows";
	}
	
	// display ranking 
	$block['rankings'] = array();
	$rank_strs = explode( ',', _MB_XOONIPS_RANKING_RANK_STR );
	for ( $i = 0; $i < count($sqls); $i++ ){
		if ( $visible[$i] ){
			$result = $xoopsDB->query( $sqls[$i] . $orderby );
			if ( $result == false ){ echo __LINE__ . $sqls[$i] . $orderby; exit; } //@@
			$items = array();
			$rank = 0;
			while ( $row_list = $xoopsDB->fetchRow( $result ) ){
				$doi = '';
				if( count( $row_list ) == 3 ) list( $id, $title, $count )       = $row_list;
				else                          list( $id, $title, $count, $doi ) = $row_list;
				if ( strlen( $title ) > $maxlen ){
					list( $title, $dummy ) = xnpTrimString( $title, $maxlen - strlen($count) - 1, _CHARSET );
					$title .= "..";
				}
				$rank_str = ($rank+1) . $rank_strs[ min($rank, count($rank_strs)-1) ];
				if( $doi != "" && XNP_CONFIG_DOI_FIELD_PARAM_NAME != "" ) {
					$id_name = XNP_CONFIG_DOI_FIELD_PARAM_NAME;
					$id      = $doi;
				} else
					$id_name = 'item_id';
				$items[] = array('title'=>$title, 'url'=>sprintf( $urls[$i], $id_name, urlencode( $id ) ), 'num'=>$count, 'rank_str' => $rank_str );
				$rank++;
			}
			$block['rankings'][$order[$i]] = array( 'items' => $items, 'title' => $ranking_names[$i] );
		}
	}
	ksort( $block['rankings'] );
	return $block;
}


function b_xoonips_ranking_show(){
	return xoonips_ranking_show( false );
}

function b_xoonips_ranking_new_show(){
	return xoonips_ranking_show( true );
}

?>
