<?php
// $Revision: 1.1.2.1 $
//  ------------------------------------------------------------------------ //
//  XooNIps - Neuroinformatics Base Platform System                          //
//  Copyright (C) 2005-2007 RIKEN, Japan All rights reserved.                //
//  http://xoonips.sourceforge.jp/                                           //
//  ------------------------------------------------------------------------ //
//  This program is free software; you can redistribute it and/or modify     //
//  it under the terms of the GNU General Public License as published by     //
//  the Free Software Foundation; either version 2 of the License, or        //
//  (at your option) any later version.                                      //
//                                                                           //
//  You may not change or alter any portion of this comment or credits       //
//  of supporting developers from this source code or any supporting         //
//  source code which is considered copyrighted (c) material of the          //
//  original comment or credit authors.                                      //
//                                                                           //
//  This program is distributed in the hope that it will be useful,          //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of           //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            //
//  GNU General Public License for more details.                             //
//                                                                           //
//  You should have received a copy of the GNU General Public License        //
//  along with this program; if not, write to the Free Software              //
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA //
//  ------------------------------------------------------------------------ //

if ( ! defined( 'XOOPS_ROOT_PATH' ) ) exit();

// helper function for item order sorting
function _xoonips_helper_itemtypes_cmp( $a, $b ){
  if ( $a['weight'] == $b['weight'] ) {
    return ( $a['mid'] < $b['mid'] ) ? -1 : 1; // mid must be uniq
  }
  return ( $a['weight'] < $b['weight'] ) ? -1 : 1;
}

// xoonips itemtypes block
function b_xoonips_itemtypes_show() {
  global $xoopsUser;

  // include functions
  require_once XOOPS_ROOT_PATH.'/modules/xoonips/include/functions.php';

  // hide block if user is guest and public index viewing policy is 'platform'
  if ( ! is_object( $xoopsUser ) ) {
    $xconfig_handler =& xoonips_getormhandler( 'xoonips', 'config' );
    $xconfig_obj =& $xconfig_handler->getConfig( 'public_item_target_user' );
    $public_item_target_user = $xconfig_obj->getVar( 'value', 'n' );
    if ( $public_item_target_user != 'all' ) { // 'platform'
      return false;
    }
  }

  // get installed itemtypes
  // TODO: xoonips_item_type table should have itemtype sort order.
  $module_handler = xoops_gethandler( 'module' );
  $itemtype_handler =& xoonips_getormhandler( 'xoonips', 'item_type' );
  $itemtype_objs =& $itemtype_handler->getObjects();
  $itemtypes = array();
  foreach ( $itemtype_objs as $itemtype_obj ) {
    $name = $itemtype_obj->getVar( 'name', 'e' );
    // TODO: support to show binder
    if ( ! in_array( $name, array( 'xoonips_index', 'xoonips_binder' ) ) ) {
      $mid = $itemtype_obj->getVar( 'mid', 'n' );
      $display_name = $itemtype_obj->getVar( 'display_name', 's' );
      $viewphp = $itemtype_obj->getVar( 'viewphp', 'n' );
      // load view.php
      if ( ! file_exists( XOOPS_ROOT_PATH.'/modules/'.$viewphp ) ) {
        continue; // view.php not found
      }
      include_once XOOPS_ROOT_PATH.'/modules/'.$viewphp;
      // call xxxGetTopBlock function in view.php
      $func = $name.'GetTopBlock';
      if ( ! function_exists( $func ) ) {
        continue; // xxxGetTopBlock function not found
      }
      $itemtype['name'] = $name; 
      $itemtype['display_name'] = $display_name; 
      $html = $func( $itemtype );
      if ( empty( $html ) ) {
        continue; // html of top block not found
      }
      $module =& $module_handler->get( $mid );
      $weight = $module->getVar( 'weight', 'n' );
      $itemtypes[] = array( 
        'mid' => $mid,
        'html' => $html,
        'weight' => $weight,
      );
    }
  }
  if ( empty( $itemtypes ) ) {
    return false; // visible itemtype not found
  }
  // sort itemtypes
  usort( $itemtypes, '_xoonips_helper_itemtypes_cmp' );

  // assign block template variables
  $block = array();
  $block['explain'] = array();
  foreach( $itemtypes as $itemtype ) {
    $block['explain'][] = $itemtype['html'];
  }

  return $block;
}

?>
