<?php
// $Revision: 1.1.2.6 $
//  ------------------------------------------------------------------------ //
//  XooNIps - Neuroinformatics Base Platform System                          //
//  Copyright (C) 2005-2007 RIKEN, Japan All rights reserved.                //
//  http://xoonips.sourceforge.jp/                                           //
//  ------------------------------------------------------------------------ //
//  This program is free software; you can redistribute it and/or modify     //
//  it under the terms of the GNU General Public License as published by     //
//  the Free Software Foundation; either version 2 of the License, or        //
//  (at your option) any later version.                                      //
//                                                                           //
//  You may not change or alter any portion of this comment or credits       //
//  of supporting developers from this source code or any supporting         //
//  source code which is considered copyrighted (c) material of the          //
//  original comment or credit authors.                                      //
//                                                                           //
//  This program is distributed in the hope that it will be useful,          //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of           //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            //
//  GNU General Public License for more details.                             //
//                                                                           //
//  You should have received a copy of the GNU General Public License        //
//  along with this program; if not, write to the Free Software              //
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA //
//  ------------------------------------------------------------------------ //

if ( ! defined( 'XOOPS_ROOT_PATH' ) ) exit();

/**
 *
 * @brief Data object of system preference
 *
 * @li getVar('name') : key
 * @li getVar('value') : value
 */
class XooNIpsConfig extends XooNIpsTableObject
{
    function XooNIpsConfig() 
    {
        parent::XooNIpsTableOBject();
        $this->initVar('id', XOBJ_DTYPE_INT, 0, false);
        $this->initVar('name', XOBJ_DTYPE_TXTBOX, null, true, 255);
        $this->initVar('value', XOBJ_DTYPE_TXTBOX, null, false, 65535);
    }
}

/**
 * @brief Handler object of system preference
 */
class XooNIpsConfigHandler extends XooNIpsTableObjectHandler
{
    function XooNIpsConfigHandler(&$db) 
    {
        parent::XooNIpsTableObjectHandler($db);
        $this->__initHandler('XooNIpsConfig', 'xoonips_config', 'id', false);
    }

    /**
     * gets a configuration value object
     *
     * @deprecated
     * @access public
     * @param string key configuration key
     * @return object XooNIpsConfig. return false if key was not found.
     */
    function &get($key) 
    {
        // TODO: remove this function, this function overrided parent method.
        //       this is not desirable spesification because of maintainance.
        //       please use getConfig() for alternative method.
        // die( 'DEBUG: please rewrite to getConfig()' );
        $configs = &$this->getObjects(new Criteria('name', addslashes($key)));
        if (!$configs || count($configs) != 1) {
            $result = false;
            return $result;
        }
        return $configs[0];
    }

    /**
     * get a configuration value object
     *
     * @access public
     * @param string key configuration key
     * @return object XooNIpsConfig. return false if key was not found.
     */
    function &getConfig( $key ) {
        $config_objs =& $this->getObjects( new Criteria( 'name', addslashes( $key ) ) );
        if ( ! $config_objs || count( $config_objs ) != 1 ) {
            $result = false;
            return $result;
        }
        return $config_objs[0];
    }

    /**
     * delete configuration
     *
     * @access public
     * @param XooNIpsConfig obj to delete
     * @return bool FALSE if failed
     */
    function delete(&$obj) 
    {
        if (strtolower(get_class($obj)) != strtolower($this->__class_name)) {
            return false;
        }
        return $this->deleteAll(new Criteria('name', addslashes($config->get('name'))));
    }
}
?>
