<?php
// $Revision: 1.1.2.6 $
//  ------------------------------------------------------------------------ //
//  XooNIps - Neuroinformatics Base Platform System                          //
//  Copyright (C) 2005-2007 RIKEN, Japan All rights reserved.                //
//  http://xoonips.sourceforge.jp/                                           //
//  ------------------------------------------------------------------------ //
//  This program is free software; you can redistribute it and/or modify     //
//  it under the terms of the GNU General Public License as published by     //
//  the Free Software Foundation; either version 2 of the License, or        //
//  (at your option) any later version.                                      //
//                                                                           //
//  You may not change or alter any portion of this comment or credits       //
//  of supporting developers from this source code or any supporting         //
//  source code which is considered copyrighted (c) material of the          //
//  original comment or credit authors.                                      //
//                                                                           //
//  This program is distributed in the hope that it will be useful,          //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of           //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            //
//  GNU General Public License for more details.                             //
//                                                                           //
//  You should have received a copy of the GNU General Public License        //
//  along with this program; if not, write to the Free Software              //
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA //
//  ------------------------------------------------------------------------ //

//  Install script for moderator module

require_once XOOPS_ROOT_PATH . '/class/database/sqlutility.php';
require_once XOOPS_ROOT_PATH . '/modules/xoonips/condefs.php';
require_once XOOPS_ROOT_PATH . '/modules/xoonips/include/lib.php';
require_once XOOPS_ROOT_PATH . '/modules/xoonips/include/create_session.php';

function xoonips_get_default_configs(){
	$configs = array(
		'moderator_gid'                 => array( 'type' => 'i'  , 'value' => ''         ),
		'certify_user'                  => array( 'type' => 's'  , 'value' => 'on'       ),
		'certify_item'                  => array( 'type' => 's'  , 'value' => 'on'       ),
		'public_item_target_user'       => array( 'type' => 's'  , 'value' => 'all'      ),
		'upload_dir'                    => array( 'type' => 's'  , 'value' => ''         ),
		'account_realname_optional'     => array( 'type' => 's'  , 'value' => 'off'      ),
		'account_address_optional'      => array( 'type' => 's'  , 'value' => 'off'      ),
		'account_division_optional'     => array( 'type' => 's'  , 'value' => 'off'      ),
		'account_tel_optional'          => array( 'type' => 's'  , 'value' => 'off'      ),
		'account_company_name_optional' => array( 'type' => 's'  , 'value' => 'off'      ),
		'account_country_optional'      => array( 'type' => 's'  , 'value' => 'off'      ),
		'account_zipcode_optional'      => array( 'type' => 's'  , 'value' => 'off'      ),
		'account_fax_optional'          => array( 'type' => 's'  , 'value' => 'off'      ),
		'private_item_number_limit'     => array( 'type' => 'i'  , 'value' => '100'      ),
		'private_index_number_limit'    => array( 'type' => 'i'  , 'value' => '50'       ),
		'private_item_storage_limit'    => array( 'type' => 'dm' , 'value' => '50000000' ),
		'group_item_number_limit'       => array( 'type' => 'i'  , 'value' => '300'      ),
		'group_index_number_limit'      => array( 'type' => 'i'  , 'value' => '200'      ),
		'group_item_storage_limit'      => array( 'type' => 'dm' , 'value' => '100000000'),
		'amazon_associates_id'          => array( 'type' => 's'  , 'value' => ''         ),
		'export_attachment'             => array( 'type' => 's'  , 'value' => 'off'      ),
		'export_enabled'                => array( 'type' => 's'  , 'value' => 'off'      ),
		'rss_file_path'                 => array( 'type' => 's'  , 'value' => ''         ),
		'rss_item_max'                  => array( 'type' => 'i'  , 'value' => '10'       ),
		'tree_frame_width'              => array( 'type' => 's'  , 'value' => '100%'     ),
		'tree_frame_height'             => array( 'type' => 's'  , 'value' => '400'      ),
		'printer_friendly_header'       => array( 'type' => 's'  , 'value' => ''         ),
		'repository_institution'        => array( 'type' => 's'  , 'value' => 'meta_author' ),
		'repository_publisher'          => array( 'type' => 's'  , 'value' => 'meta_author' ),
		'repository_name'               => array( 'type' => 's'  , 'value' => ''         ),
		'repository_nijc_code'          => array( 'type' => 's'  , 'value' => ''         ),
		'repository_deletion_track'     => array( 'type' => 's'  , 'value' => '30'       ),
		'download_file_compression'     => array( 'type' => 's'  , 'value' => 'on'       ),
		'item_show_optional'            => array( 'type' => 's'  , 'value' => 'off'      ),
		'private_import_enabled'        => array( 'type' => 's'  , 'value' => 'off'      ),
		'moderator_modify_any_items'    => array( 'type' => 's'  , 'value' => 'off'      ),
		'proxy_host'    => array( 'type' => 's'  , 'value' => ''      ),
		'proxy_port'    => array( 'type' => 'i'  , 'value' => '80'      ),
		'proxy_user'    => array( 'type' => 's'  , 'value' => ''      ),
		'proxy_pass'    => array( 'type' => 's'  , 'value' => ''      ),
		'magic_file_path' => array( 'type' => 's', 'value' => '/usr/share/misc/magic' ),
		'ranking_num_rows' => array( 'type' => 'i', 'value' => '5' ),
		'ranking_order' => array( 'type' => 's', 'value' => '0,1,2,3,4' ),
		'ranking_visible' => array( 'type' => 's', 'value' => '1,1,1,1,1' ),
		'ranking_new_num_rows' => array( 'type' => 'i', 'value' => '5' ),
		'ranking_new_order' => array( 'type' => 's', 'value' => '0,1' ),
		'ranking_new_visible' => array( 'type' => 's', 'value' => '1,1' ),
		'ranking_days' => array( 'type' => 'i', 'value' => '14' ),
		'ranking_days_enabled' => array( 'type' => 's', 'value' => '' ),
		'ranking_lock_timeout' => array( 'type' => 'i', 'value' => '0' ),
		'ranking_last_update' => array( 'type' => 'i', 'value' => '0' ),
		'ranking_sum_start' => array( 'type' => 'i', 'value' => '0' ),
		'ranking_sum_last_update' => array( 'type' => 'i', 'value' => '0' ),
	);
	return $configs;
}

// Unset items in xoonips_config is set.
function xoonips_insert_default_configs(){
	$configs = xoonips_get_default_configs();
	global $xoopsDB;
	$table = $xoopsDB->prefix('xoonips_config');
	foreach ( $configs as $key => $ar ){
		$escKey = addslashes( $key );
		$escVal = addslashes( $ar['value'] );
		
		$result = $xoopsDB->query( "select value from $table where name='$escKey'" );
		if ( $xoopsDB->getRowsNum($result) == 0 ){
			$result = $xoopsDB->query( "insert into $table ( name, value ) values ('$escKey', '$escVal' )" );
		}
	}
}

function xoonips_get_obsolete_configs(){
	$configs = array(
		'amazon_associates_id',
	);
	return $configs;
}

// removed obsolete configs 
function xoonips_delete_obsolete_configs(){
	$configs = xoonips_get_obsolete_configs();
	global $xoopsDB;
	$table = $xoopsDB->prefix('xoonips_config');
	foreach ( $configs as $key ){
		$escKey = addslashes( $key );
		
		$result = $xoopsDB->query( "select value from $table where name='$escKey'" );
		if ( $xoopsDB->getRowsNum($result) != 0 ){
			$result = $xoopsDB->query( "delete from $table where name='$escKey'" );
		}
	}
}

function xoops_module_update_xoonips( $xoopsMod, $oldversion ) {
  global $xoopsDB;

  if ( $oldversion < 324 ) {
    echo "<code>The update does not supported before ver 3.24.</code><br />";
    return false;
  }

  echo "<code>Updating modules...</code><br />";
  switch ( $oldversion ) {
  case 324:
    // TODO: config check
    xoonips_insert_default_configs();
    // TODO: sql check
    $sqls = <<<SQL
-- xoonips_file
ALTER TABLE xoonips_file
	MODIFY file_size int(10) unsigned NOT NULL default '0',
	MODIFY file_type_id int(10) unsigned NOT NULL default '0',
	ADD is_deleted TINYINT(1) UNSIGNED NOT NULL DEFAULT '0',
	ADD download_count INT(10) UNSIGNED NOT NULL DEFAULT '0';
-- xoonips_file_type
ALTER TABLE xoonips_file_type  MODIFY name VARCHAR(30) NOT NULL DEFAULT '';
-- xoonips_item_basic
ALTER TABLE xoonips_item_basic 
	DROP title,
	DROP keywords;
-- xoonips_item_keyword
ALTER TABLE xoonips_item_keyword  DROP PRIMARY KEY,
	ADD seq_id INT( 10 ) UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY FIRST,
	CHANGE keyword keyword VARCHAR( 255 ) NOT NULL default '',
	ADD UNIQUE (item_id ,keyword_id );
-- xoonips_item_title
ALTER TABLE xoonips_item_title  DROP PRIMARY KEY,
	ADD seq_id INT( 10 ) UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY FIRST,
	CHANGE title title VARCHAR( 255 ) NOT NULL default '',
	ADD UNIQUE (item_id ,title_id );
-- xoonips_position
ALTER TABLE xoonips_positions  ADD UNIQUE KEY posi_title (posi_title);
-- 
ALTER TABLE xoonips_ranking_active_group 
	MODIFY gid int(10) unsigned NOT NULL default '0',
	MODIFY count int(10) unsigned NOT NULL default '0';
ALTER TABLE xoonips_ranking_contributing_user 
	MODIFY item_id int(10) unsigned NOT NULL default '0',
	MODIFY uid int(10) unsigned NOT NULL default '0';
ALTER TABLE xoonips_ranking_downloaded_item 
	MODIFY item_id int(10) unsigned NOT NULL default '0',
	MODIFY count int(10) unsigned NOT NULL default '0';
ALTER TABLE xoonips_ranking_new_group MODIFY gid int(10) unsigned NOT NULL default '0';
ALTER TABLE xoonips_ranking_new_item MODIFY item_id int(10) unsigned NOT NULL default '0';
ALTER TABLE xoonips_ranking_searched_keyword 
	MODIFY keyword varchar(255) BINARY NOT NULL default '',
	MODIFY count int(10) unsigned NOT NULL default '0';
ALTER TABLE xoonips_ranking_sum_active_group 
	MODIFY gid int(10) unsigned NOT NULL default '0',
	MODIFY count int(10) unsigned NOT NULL default '0';
ALTER TABLE xoonips_ranking_sum_contributing_user 
	MODIFY item_id int(10) unsigned NOT NULL default '0',
	MODIFY uid int(10) unsigned NOT NULL default '0';
ALTER TABLE xoonips_ranking_sum_downloaded_item 
	MODIFY item_id int(10) unsigned NOT NULL default '0',
	MODIFY count int(10) unsigned NOT NULL default '0';
ALTER TABLE xoonips_ranking_sum_new_group MODIFY gid int(10) unsigned NOT NULL default '0';
ALTER TABLE xoonips_ranking_sum_new_item MODIFY item_id int(10) unsigned NOT NULL default '0';
ALTER TABLE xoonips_ranking_sum_searched_keyword 
	MODIFY keyword varchar(255) BINARY NOT NULL default '',
	MODIFY count int(10) unsigned NOT NULL default '0';
ALTER TABLE xoonips_ranking_sum_viewed_item 
	MODIFY item_id int(10) unsigned NOT NULL default '0',
	MODIFY count int(10) unsigned NOT NULL default '0';
ALTER TABLE xoonips_ranking_viewed_item 
	MODIFY item_id int(10) unsigned NOT NULL default '0',
	MODIFY count int(10) unsigned NOT NULL default '0';
ALTER TABLE xoonips_related_to
	DROP PRIMARY KEY,
	ADD related_to_id int(10) unsigned NOT NULL AUTO_INCREMENT PRIMARY KEY FIRST,
	MODIFY parent_id int(10) unsigned NOT NULL default '0',
	MODIFY item_id int(10) unsigned NOT NULL default '0',
    ADD UNIQUE KEY related_to (parent_id,item_id);
ALTER TABLE xoonips_search_cache MODIFY sess_id varchar(32) NOT NULL default '';
ALTER TABLE xoonips_search_cache_file MODIFY search_cache_id int(10) unsigned NOT NULL default '0';
ALTER TABLE xoonips_search_cache_item
	DROP PRIMARY KEY,
	ADD search_cache_item_id int(10) NOT NULL AUTO_INCREMENT PRIMARY KEY FIRST,
	MODIFY search_cache_id int(10) unsigned NOT NULL default '0',
	ADD matchfor_index tinyint(1) NOT NULL default '0',
	ADD matchfor_item tinyint(1) NOT NULL default '0',
	ADD matchfor_file tinyint(1) NOT NULL default '0',
	ADD UNIQUE KEY search_cache_id (search_cache_id,item_id);
ALTER TABLE xoonips_search_cache_metadata 
	MODIFY search_cache_id int(10) unsigned NOT NULL default '0',
	MODIFY identifier varchar(255) NOT NULL default '';
ALTER TABLE xoonips_search_text MODIFY file_id int(10) unsigned NOT NULL default '0';
ALTER TABLE xoonips_session MODIFY uid int(10) unsigned NOT NULL default '0';
SQL;

		// queries
		if( !query_sqls($sqls) ){
			return false;
		}
		
		// clean up unlinked item
		$xoopsDB -> query( sprintf( "DELETE FROM %s WHERE item_id=0", $xoopsDB -> prefix( 'xoonips_related_to' ) ) );
		$xoopsDB -> query( sprintf( "DELETE FROM %s WHERE item_id=0", $xoopsDB -> prefix( 'xoonips_index_item_link' ) ) );
		
		// enable use of notification 'file_downloaded'
		$config_handler =& xoops_gethandler('config');
		$module_id = $xoopsMod->getVar('mid');
		$criteria = new CriteriaCompo(new Criteria('conf_name', 'notification_events'));
		$criteria->add(new Criteria('conf_modid', $module_id));
		$criteria->add(new Criteria('conf_catid', 0));
		$config_items = $config_handler->getConfigs( $criteria );
		if ( count($config_items) != 1 ){
			echo '&nbsp;&nbsp;'. "module has " . count($config_items) . " notification_events options line at " . __LINE__ .'<br />';
		}
		else {
			$config_item = $config_items[0];
			$option_value = 'user-file_downloaded';
			$option_values = $config_item->getConfValueForOutput();
			if ( !in_array( $option_value, $option_values ) ){
				$option_values[] = $option_value;
				$config_item->setConfValueForInput( $option_values );
				$config_item_handler =& new XoopsConfigItemHandler($xoopsDB);
				$config_item_handler->insert($config_item);
			}
		}
    xoonips_delete_obsolete_configs();
  case 330:
    // fixed default xoonips group bug.
    // if xoonips was installed before 3.24, then the administrator have 
    // joined to group id 0. this group id have to be GID_DEFAULT(1).
    $sql = sprintf( 'UPDATE %s SET gid=1 WHERE gid=0', $xoopsDB->prefix( 'xoonips_groups_users_link' ) );
    $xoopsDB->query( $sql );
    
    // fixed ranking bug.
    $sqls = <<<SQL
-- 
ALTER TABLE xoonips_config
    TYPE=innodb;
-- 
ALTER TABLE xoonips_ranking_viewed_item
    TYPE=innodb;
-- 
ALTER TABLE xoonips_ranking_downloaded_item
    TYPE=innodb;
-- 
ALTER TABLE xoonips_ranking_contributing_user
    TYPE=innodb;
-- 
ALTER TABLE xoonips_ranking_searched_keyword
    TYPE=innodb;
-- 
ALTER TABLE xoonips_ranking_active_group
    TYPE=innodb;
-- 
ALTER TABLE xoonips_ranking_new_item
    TYPE=innodb;
-- 
ALTER TABLE xoonips_ranking_new_group
    TYPE=innodb;
-- 
ALTER TABLE xoonips_ranking_sum_viewed_item
    TYPE=innodb;
-- 
ALTER TABLE xoonips_ranking_sum_downloaded_item
    TYPE=innodb;
-- 
ALTER TABLE xoonips_ranking_sum_contributing_user
    TYPE=innodb;
-- 
ALTER TABLE xoonips_ranking_sum_searched_keyword
    TYPE=innodb;
-- 
ALTER TABLE xoonips_ranking_sum_active_group
    TYPE=innodb;
-- 
ALTER TABLE xoonips_ranking_sum_new_item
    TYPE=innodb;
-- 
ALTER TABLE xoonips_ranking_sum_new_group
    TYPE=innodb;
SQL;
    // queries
    if( !query_sqls($sqls) ){
        return false;
    }
    
  }
  
  return true;
}

/**
 * @split $sqls to individual queries, add prefix to table, and query sqls
 * output some informations to stdout.
 * 
 * @param string $sqls string of sqls.
 * @return boolean true if succeed
 * 
 */
function query_sqls($sqls){
	global $xoopsDB;
	$pieces = array();
	SqlUtility::splitMySqlFile($pieces, $sqls);
	$created_tables = array();
	$errs = array();
	$msgs = array();
	$error = false;
	$ret = '';
	foreach ($pieces as $piece) {
		// [0] contains the prefixed query
		// [4] contains unprefixed table name
		$prefixed_query = SqlUtility::prefixQuery($piece, $xoopsDB->prefix());
		if (!$prefixed_query) {
			$errs[] = "<b>$piece</b> is not a valid SQL!";
			$error = true;
			break;
		}
		if (!$xoopsDB->query($prefixed_query[0])) {
			$errs[] = $xoopsDB->error() . ' of SQL '.htmlspecialchars($prefixed_query[0]);
			$error = true;
			break;
		} else {
			
			if (strncmp('CREATE', strtoupper($prefixed_query[0]), 6) == 0 && !in_array($prefixed_query[4], $created_tables)) {
				$msgs[] = '&nbsp;&nbsp;Table <b>'.$xoopsDB->prefix($prefixed_query[4]).'</b> created.';
				$created_tables[] = $prefixed_query[4];
			}
		}
	}
	// if there was an error, delete the tables created so far, so the next installation will not fail
	if ($error == true) {
		foreach ($created_tables as $ct) {
			//echo $ct;
			$xoopsDB->query("DROP TABLE ".$xoopsDB->prefix($ct));
		}
	}
	
	if( $error ){
		foreach ($errs as $er) {
			$ret .= '&nbsp;&nbsp;'.$er.'<br />';
		}
		unset($msgs);
		unset($errs);
	}
	echo $ret;
	return !$error;
}

function fetch_column( $table, $column ){
	global $xoopsDB;
	$result = $xoopsDB -> query( 'SHOW COLUMNS FROM ' . $xoopsDB -> prefix( $table ) . ' WHERE Field = ' . $xoopsDB -> quoteString( $column ) );
    return $xoopsDB -> fetchArray( $result );
}
?>
