<?php
// $Revision: 1.23.4.7 $
//  ------------------------------------------------------------------------ //
//  XooNIps - Neuroinformatics Base Platform System                          //
//  Copyright (C) 2005-2007 RIKEN, Japan All rights reserved.                //
//  http://xoonips.sourceforge.jp/                                           //
//  ------------------------------------------------------------------------ //
//  This program is free software; you can redistribute it and/or modify     //
//  it under the terms of the GNU General Public License as published by     //
//  the Free Software Foundation; either version 2 of the License, or        //
//  (at your option) any later version.                                      //
//                                                                           //
//  You may not change or alter any portion of this comment or credits       //
//  of supporting developers from this source code or any supporting         //
//  source code which is considered copyrighted (c) material of the          //
//  original comment or credit authors.                                      //
//                                                                           //
//  This program is distributed in the hope that it will be useful,          //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of           //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            //
//  GNU General Public License for more details.                             //
//                                                                           //
//  You should have received a copy of the GNU General Public License        //
//  along with this program; if not, write to the Free Software              //
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA //
//  ------------------------------------------------------------------------ //
//  Modified like below for XooNIps                                          //
//  - XooNIps user information form and parameter check is added(2005/5/18)  //
//  - XooNIps event of account is added(2005/7/7)                            //
//  - Send e-mail for moderator(2006/9/5)                                    //
//  ------------------------------------------------------------------------ //

$xoopsOption['pagetype'] = 'user';

include '../../mainfile.php';
include_once 'include/lib.php';
require_once 'include/create_session.php';
require_once 'class/base/gtickets.php';
xnp_load_init_create_session();

$myts =& MyTextSanitizer::getInstance();

$config_handler =& xoops_gethandler('config');
$xoopsConfigUser =& $config_handler->getConfigsByCat(XOOPS_CONF_USER);

if (empty($xoopsConfigUser['allow_register'])) {
    redirect_header( XOOPS_URL.'/', 6, _US_NOREGISTER );
    exit();
}

function userCheck($uname, $email, $pass, $vpass)
{
    global $xoopsConfigUser;
    $xoopsDB =& Database::getInstance();
    $myts =& MyTextSanitizer::getInstance();
    $stop = '';
    if (!checkEmail($email)) {
        $stop .= _US_INVALIDMAIL.'<br />';
    }
    foreach ($xoopsConfigUser['bad_emails'] as $be) {
        if (!empty($be) && preg_match("/".$be."/i", $email)) {
            $stop .= _US_INVALIDMAIL.'<br />';
            break;
        }
    }
    if (strrpos($email,' ') > 0) {
        $stop .= _US_EMAILNOSPACES.'<br />';
    }
    $uname = xoops_trim($uname);
    switch ($xoopsConfigUser['uname_test_level']) {
    case 0:
        // strict
        $restriction = '/[^a-zA-Z0-9\_\-]/';
        break;
    case 1:
        // medium
        $restriction = '/[^a-zA-Z0-9\_\-\<\>\,\.\$\%\#\@\!\\\'\"]/';
        break;
    case 2:
        // loose
        $restriction = '/[\000-\040]/';
        break;
    }
    if (empty($uname) || preg_match($restriction, $uname)) {
        $stop .= _US_INVALIDNICKNAME."<br />";
    }
    if (strlen($uname) > $xoopsConfigUser['maxuname']) {
        $stop .= sprintf(_US_NICKNAMETOOLONG, $xoopsConfigUser['maxuname'])."<br />";
    }
    if (strlen($uname) < $xoopsConfigUser['minuname']) {
        $stop .= sprintf(_US_NICKNAMETOOSHORT, $xoopsConfigUser['minuname'])."<br />";
    }
    foreach ($xoopsConfigUser['bad_unames'] as $bu) {
        if (!empty($bu) && preg_match("/".$bu."/i", $uname)) {
            $stop .= _US_NAMERESERVED."<br />";
            break;
        }
    }
    if (strrpos($uname, ' ') > 0) {
        $stop .= _US_NICKNAMENOSPACES."<br />";
    }
    $sql = sprintf('SELECT COUNT(*) FROM %s WHERE uname = %s', $xoopsDB->prefix('users'), $xoopsDB->quoteString(addslashes($uname)));
    $result = $xoopsDB->query($sql);
    list($count) = $xoopsDB->fetchRow($result);
    if ($count > 0) {
        $stop .= _US_NICKNAMETAKEN."<br />";
    }
    $count = 0;
    if ( $email ) {
        $sql = sprintf('SELECT COUNT(*) FROM %s WHERE email = %s', $xoopsDB->prefix('users'), $xoopsDB->quoteString(addslashes($email)));
        $result = $xoopsDB->query($sql);
        list($count) = $xoopsDB->fetchRow($result);
        if ( $count > 0 ) {
            $stop .= _US_EMAILTAKEN."<br />";
        }
    }
    if ( !isset($pass) || $pass == '' || !isset($vpass) || $vpass == '' ) {
        $stop .= _US_ENTERPWD.'<br />';
    }
    if ( (isset($pass)) && ($pass != $vpass) ) {
        $stop .= _US_PASSNOTSAME.'<br />';
    } elseif ( ($pass != '') && (strlen($pass) < $xoopsConfigUser['minpass']) ) {
        $stop .= sprintf(_US_PWDTOOSHORT,$xoopsConfigUser['minpass'])."<br />";
    }
    return $stop;
}

function userCheckXooNIps( $realname, $address, $division, $tel, $company_name, $country, $zipcode, $fax, $notice_mail ) {
  global $required;
  $errors = array();
  // acquire required flags of XooNIps user information
  $check_fields = array(
    // 'post key' => array( 'label', maxlength, 'error message' ),
    'realname' => array( _US_REALNAME, null, null ),
    'address' => array( _MD_XOONIPS_ACCOUNT_ADDRESS, 255, _MD_XOONIPS_ACCOUNT_REG_TOO_LONG_ADDRESS ),
    'division' => array( _MD_XOONIPS_ACCOUNT_DIVISION, 255, _MD_XOONIPS_ACCOUNT_REG_TOO_LONG_DIVISION ),
    'tel' => array( _MD_XOONIPS_ACCOUNT_TEL, 32, _MD_XOONIPS_ACCOUNT_REG_TOO_LONG_TEL ),
    'company_name' => array( _MD_XOONIPS_ACCOUNT_COMPANY_NAME, 255, _MD_XOONIPS_ACCOUNT_REG_TOO_LONG_COMPANY_NAME ),
    'country' => array( _MD_XOONIPS_ACCOUNT_COUNTRY, 255, _MD_XOONIPS_ACCOUNT_REG_TOO_LONG_COUNTRY ),
    'zipcode' => array( _MD_XOONIPS_ACCOUNT_ZIPCODE, 32, _MD_XOONIPS_ACCOUNT_REG_TOO_LONG_ZIPCODE ),
    'fax' => array( _MD_XOONIPS_ACCOUNT_FAX, 32, _MD_XOONIPS_ACCOUNT_REG_TOO_LONG_FAX ),
  );
  // -- notice mail
  if ( $notice_mail < 0 ) {
    $errors[] = _MD_XOONIPS_ACCOUNT_NOTICE_MAIL_TOO_LITTLE;
  }
  // -- requirements
  foreach ( $check_fields as $key => $info ) {
    list( $label, $maxlength, $errmes ) = $info;
    if ( $required[$key]['flag'] && ${$key} == '' ) {
        $errors[] = sprintf( _MD_XOONIPS_ACCOUNT_MUST_BE_FILLED_IN, $label );
    }
  }
  // -- field length
  foreach ( $check_fields as $key => $info ) {
    list( $label, $maxlength, $errmes ) = $info;
    if ( ! is_null( $maxlength ) && strlen( ${$key} ) > $maxlength ) {
      $errors[] = $errmes;
    }
  }
  $stop = '';
  if ( count( $errors ) > 0 ) {
    $stop = implode( '<br />'."\n", $errors ).'<br />'."\n";
  }
  return $stop;
}

function getXooNIpsConfig( $key ) {
  $value = '';
  if ( xnp_get_config_value( $key, $value ) != RES_OK ) {
    die( 'Fatal error : xoonips config \''.$key.'\' not found' );
  }
  return $value;
}

$op = !isset($_POST['op']) ? 'register' : $_POST['op'];
$uname = isset($_POST['uname']) ? $myts->stripSlashesGPC($_POST['uname']) : '';
$email = isset($_POST['email']) ? trim($myts->stripSlashesGPC($_POST['email'])) : '';
$url = isset($_POST['url']) ? trim($myts->stripSlashesGPC($_POST['url'])) : '';
$pass = isset($_POST['pass']) ? $myts->stripSlashesGPC($_POST['pass']) : '';
$vpass = isset($_POST['vpass']) ? $myts->stripSlashesGPC($_POST['vpass']) : '';
$timezone_offset = isset($_POST['timezone_offset']) ? intval($_POST['timezone_offset']) : $xoopsConfig['default_TZ'];
$user_viewemail = (isset($_POST['user_viewemail']) && intval($_POST['user_viewemail'])) ? 1 : 0;
$user_mailok = (isset($_POST['user_mailok']) && intval($_POST['user_mailok'])) ? 1 : 0;
$agree_disc = (isset($_POST['agree_disc']) && intval($_POST['agree_disc'])) ? 1 : 0;

// for xoonips user information
$realname = isset($_POST['realname']) ? trim($myts->stripSlashesGPC($_POST['realname'])) : '';
$address = isset($_POST['address']) ? trim($myts->stripSlashesGPC($_POST['address'])) : '';
$division = isset($_POST['division']) ? trim($myts->stripSlashesGPC($_POST['division'])) : '';
$tel = isset($_POST['tel']) ? trim($myts->stripSlashesGPC($_POST['tel'])) : '';
$company_name = isset($_POST['company_name']) ? trim($myts->stripSlashesGPC($_POST['company_name'])) : '';
$country = isset($_POST['country']) ? trim($myts->stripSlashesGPC($_POST['country'])) : '';
$zipcode = isset($_POST['zipcode']) ? trim($myts->stripSlashesGPC($_POST['zipcode'])) : '';
$fax = isset($_POST['fax']) ? trim($myts->stripSlashesGPC($_POST['fax'])) : '';
$notice_mail = isset($_POST['notice_mail']) ? intval($_POST['notice_mail']) : 0;

// get and check xoonips configuration
$certify_user = getXooNIpsConfig( 'certify_user' );
$moderator_gid = getXooNIpsConfig( 'moderator_gid' );
$is_certify_auto = ( $certify_user == 'auto' );
$required = array();
foreach ( array( 'realname', 'address', 'division', 'tel', 'company_name', 'country', 'zipcode', 'fax' ) as $key ) {
  $optional = getXooNIpsConfig( 'account_'.$key.'_optional' );
  if ( $optional == 'on' ) {
    $required[$key] = array( 'flag' => false, 'mark' => '' );
  } else {
    $required[$key] = array( 'flag' => true, 'mark' => _MD_XOONIPS_ACCOUNT_REQUIRED_MARK );
  }
}

switch ( $op ) {
case 'newuser':
    if ( ! $xoopsGTicket->check( true, 'register_newuser' ) ) {
        exit();
    }
    include XOOPS_ROOT_PATH.'/header.php';
    $stop = '';
    if ($xoopsConfigUser['reg_dispdsclmr'] != 0 && $xoopsConfigUser['reg_disclaimer'] != '') {
        if (empty($agree_disc)) {
            $stop .= _US_UNEEDAGREE.'<br />';
        }
    }

    $stop .= userCheck($uname, $email, $pass, $vpass);
    $stop .= userCheckXooNIps($realname, $address, $division, $tel, $company_name, $country, $zipcode, $fax, $notice_mail);
    
    if (empty($stop)) {
        echo _US_USERNAME.": ".$myts->htmlSpecialChars($uname)."<br />";
        echo _US_EMAIL.": ".$myts->htmlSpecialChars($email)."<br />";
        if ($url != '') {
            $url = formatURL($url);
            echo _US_WEBSITE.': '.$myts->htmlSpecialChars($url).'<br />';
        }
        $f_timezone = ($timezone_offset < 0) ? 'GMT '.$timezone_offset : 'GMT +'.$timezone_offset;
        echo _US_TIMEZONE.": $f_timezone<br />";
        // display user information for XooNIps
        echo _MD_XOONIPS_ACCOUNT_ADDRESS.": ".$myts->htmlSpecialChars($address)."<br />";
        echo _MD_XOONIPS_ACCOUNT_DIVISION.": ".$myts->htmlSpecialChars($division)."<br />";
        echo _MD_XOONIPS_ACCOUNT_COMPANY_NAME.": ".$myts->htmlSpecialChars($company_name)."<br />";
        echo _MD_XOONIPS_ACCOUNT_TEL.": ".$myts->htmlSpecialChars($tel)."<br />";
        echo _MD_XOONIPS_ACCOUNT_FAX.": ".$myts->htmlSpecialChars($fax)."<br />";
        echo _MD_XOONIPS_ACCOUNT_ADDRESS.": ".$myts->htmlSpecialChars($address)."<br />";
        echo _MD_XOONIPS_ACCOUNT_COUNTRY.": ".$myts->htmlSpecialChars($country)."<br />";
        echo _MD_XOONIPS_ACCOUNT_ZIPCODE.": ".$myts->htmlSpecialChars($zipcode)."<br />";
        echo _MD_XOONIPS_ACCOUNT_NOTICE_MAIL.": ".$myts->htmlSpecialChars($notice_mail)."<br />";
        echo "<form action='registeruser.php' method='post'>";
        echo $xoopsGTicket->getTicketHtml( __LINE__, 1800, 'register_finish' );
		echo "<input type='hidden' name='uname' value='".$myts->htmlSpecialChars($uname)."' />
        <input type='hidden' name='email' value='".$myts->htmlSpecialChars($email)."' />";
        echo "<input type='hidden' name='user_viewemail' value='".$user_viewemail."' />
        <input type='hidden' name='timezone_offset' value='".(float)$timezone_offset."' />
        <input type='hidden' name='url' value='".$myts->htmlSpecialChars($url)."' />
        <input type='hidden' name='pass' value='".$myts->htmlSpecialChars($pass)."' />
        <input type='hidden' name='vpass' value='".$myts->htmlSpecialChars($vpass)."' />
        <input type='hidden' name='user_mailok' value='".$user_mailok."' />";
        // for xoonips user information
        echo "<input type='hidden' name='realname' value='".$myts->htmlSpecialChars($realname)."' />
        <input type='hidden' name='division' value='".$myts->htmlSpecialChars($division)."' />
        <input type='hidden' name='company_name' value='".$myts->htmlSpecialChars($company_name)."' />
        <input type='hidden' name='tel' value='".$myts->htmlSpecialChars($tel)."' />
        <input type='hidden' name='fax' value='".$myts->htmlSpecialChars($fax)."' />
        <input type='hidden' name='address' value='".$myts->htmlSpecialChars($address)."' />
        <input type='hidden' name='country' value='".$myts->htmlSpecialChars($country)."' />
        <input type='hidden' name='zipcode' value='".$myts->htmlSpecialChars($zipcode)."' />
        <input type='hidden' name='notice_mail' value='".$notice_mail."' />
        <br /><br /><input type='hidden' name='op' value='finish' /><input class='formButton' type='submit' value='". _US_FINISH ."' /></form>";
    } else {
        echo "<span style='color:#ff0000;'>$stop</span>";
        echo "<br />" . _MD_XOONIPS_ACCOUNT_EXPLAIN_REQUIRED_MARK. "<br />\n";
        include 'include/registerform.php';
        $reg_form->display();
    }
    include XOOPS_ROOT_PATH.'/footer.php';
    break;
case 'finish':
    if ( ! $xoopsGTicket->check( true, 'register_finish' ) ) {
        exit();
    }
    include XOOPS_ROOT_PATH.'/header.php';
    $stop = userCheck($uname, $email, $pass, $vpass);
    $stop .= userCheckXooNIps($realname, $address, $division, $tel, $company_name, $country, $zipcode, $fax, $notice_mail);
    if ( empty($stop) ) {
        $member_handler =& xoops_gethandler('member');
        $newuser =& $member_handler->createUser();
        $newuser->setVar('user_viewemail',$user_viewemail, true);
        $newuser->setVar('uname', $uname, true);
        $newuser->setVar('email', $email, true);
        if ($url != '') {
            $newuser->setVar('url', formatURL($url), true);
        }
        $newuser->setVar('user_avatar','blank.gif', true);
        $actkey = substr(md5(uniqid(mt_rand(), 1)), 0, 8);
        $newuser->setVar('actkey', $actkey, true);
        $newuser->setVar('pass', md5($pass), true);
        $newuser->setVar('timezone_offset', $timezone_offset, true);
        $newuser->setVar('user_regdate', time(), true);
        $newuser->setVar('uorder',$xoopsConfig['com_order'], true);
        $newuser->setVar('umode',$xoopsConfig['com_mode'], true);
        $newuser->setVar('user_mailok',$user_mailok, true);
        $newuser->setVar('name', $realname, true);
        if ($xoopsConfigUser['activation_type'] == 1) {
            $newuser->setVar('level', 1, true);
        }
        if (!$member_handler->insertUser($newuser)) {
            echo _US_REGISTERNG;
            include  XOOPS_ROOT_PATH.'/footer.php';
            exit();
        }
        $newid = $newuser->getVar('uid');
        if (!$member_handler->addUserToGroup(XOOPS_GROUP_USERS, $newid)) {
            echo _US_REGISTERNG;
            include XOOPS_ROOT_PATH.'/footer.php';
            exit();
        }

        // create XooNIps user information
        include_once 'include/functions.php';
        // - pickup XOOPS user
        $xm_handler =& xoonips_gethandler( 'member' );
        if ( ! $xm_handler->pickupXoopsUser( $newid, $is_certify_auto ) ) {
            echo _US_REGISTERNG;
            include XOOPS_ROOT_PATH.'/footer.php';
            exit();
        }
        // - update XooNIps user informations
        $xu_handler =& xoonips_getormhandler( 'xoonips', 'users' );
        $xu_obj =& $xu_handler->get( $newid );
        $xu_obj->setVar( 'division', $division, true ); // not gpc
        $xu_obj->setVar( 'company_name', $company_name, true ); // not gpc
        $xu_obj->setVar( 'tel', $tel, true ); // not gpc
        $xu_obj->setVar( 'fax', $fax, true ); // not gpc
        $xu_obj->setVar( 'address', $address, true ); // not gpc
        $xu_obj->setVar( 'country', $country, true ); // not gpc
        $xu_obj->setVar( 'zipcode', $zipcode, true ); // not gpc
        $xu_obj->setVar( 'notice_mail', $notice_mail, true ); // not gpc
        $xu_handler->insert( $xu_obj );

        // send mail
        if ($xoopsConfigUser['activation_type'] == 0) {
            // activate xoops account by user
            $xoopsMailer =& getMailer();
            $xoopsMailer->useMail();
            $xoopsMailer->setTemplateDir(XOOPS_ROOT_PATH.'/modules/xoonips/language/'.$xoopsConfig['language'].'/mail_template/');
            if ( $is_certify_auto ) {
                // XOOPS : by user, XooNIps : auto
                $xoopsMailer->setTemplate('xoonips_activate_by_user_certify_auto.tpl');
            } else {
                // XOOPS : by user, XooNIps : moderator
                $xoopsMailer->setTemplate('xoonips_activate_by_user_certify_manual.tpl');
            }
            $xoopsMailer->assign('X_UACTLINK', XOOPS_URL.'/modules/xoonips/user.php?op=actv&id='.$newid."&actkey=".$actkey);
            $xoopsMailer->assign('SITENAME', $xoopsConfig['sitename']);
            $xoopsMailer->assign('ADMINMAIL', $xoopsConfig['adminmail']);
            $xoopsMailer->assign('SITEURL', XOOPS_URL."/");
            $xoopsMailer->setToUsers(new XoopsUser($newid));
            $xoopsMailer->setFromEmail($xoopsConfig['adminmail']);
            $xoopsMailer->setFromName($xoopsConfig['sitename']);
            $xoopsMailer->setSubject(sprintf(_MD_XOONIPS_ACTIVATE_KEY_SUBJECT,$uname));
            if ( !$xoopsMailer->send() ) {
                echo _US_YOURREGMAILNG;
            } else {
                if( $is_certify_auto ){
                    echo _MD_XOONIPS_ACTIVATE_BY_USER_CERTIFY_AUTO;
                } else {
                    echo _MD_XOONIPS_ACTIVATE_BY_USER_CERTIFY_MANUAL;
                }
            }
        } elseif ($xoopsConfigUser['activation_type'] == 1) {
            // activate xoops account automatically
            // - To send a e-mail to users who are belong to the group
            //   specified by moderator_gid if certify_user is 'manual'
            if( ! $is_certify_auto ) {
                // XOOPS : auto, XooNIps : moderator
                $xoopsMailer =& getMailer();
                $xoopsMailer->useMail();
                $member_handler =& xoops_gethandler('member');
                $xoopsMailer->setTemplateDir(XOOPS_ROOT_PATH.'/modules/xoonips/language/'.$xoopsConfig['language'].'/mail_template/');
                $xoopsMailer->setTemplate('xoonips_certify_manual.tpl');
                $xoopsMailer->assign('USERNAME', $uname );
                $xoopsMailer->assign('USEREMAIL', $email );
                $xoopsMailer->assign('USERACTLINK', XOOPS_URL.'/modules/xoonips/certifyuser.php' );
                $xoopsMailer->assign('USERINFOLINK', XOOPS_URL.'/modules/xoonips/userinfo.php?uid='.$newid);
                $xoopsMailer->assign('SITENAME', $xoopsConfig['sitename']);
                $xoopsMailer->assign('ADMINMAIL', $xoopsConfig['adminmail']);
                $xoopsMailer->assign('SITEURL', XOOPS_URL."/");
                $xoopsMailer->setToGroups($member_handler->getGroup($moderator_gid));
                $xoopsMailer->setFromEmail($xoopsConfig['adminmail']);
                $xoopsMailer->setFromName($xoopsConfig['sitename']);
                $xoopsMailer->setSubject(_MD_XOONIPS_ACCOUNT_REGISTERD);
                if ( !$xoopsMailer->send() ) {
                    echo _MD_XOONIPS_ACTIVATE_AUTO_CERTIFY_MANUAL_MAILNG;
                } else {
                    echo _MD_XOONIPS_ACTIVATE_AUTO_CERTIFY_MANUAL;
                }
            } else {
                // XOOPS : auto, XooNIps : auto
                redirect_header( 'user.php', 5, _MD_XOONIPS_ACTIVATE_AUTO_CERTIFY_AUTO, false );
            }
        } elseif ($xoopsConfigUser['activation_type'] == 2) {
            // activate xoops accunt by xoops administrator
            $xoopsMailer =& getMailer();
            $xoopsMailer->useMail();
            $xoopsMailer->setTemplate('adminactivate.tpl');
            $xoopsMailer->assign('USERNAME', $uname);
            $xoopsMailer->assign('USEREMAIL', $email);
            $xoopsMailer->assign('USERACTLINK', XOOPS_URL."/modules/xoonips/user.php?op=actv&id=".$newid."&actkey=".$actkey);
            $xoopsMailer->assign('SITENAME', $xoopsConfig['sitename']);
            $xoopsMailer->assign('ADMINMAIL', $xoopsConfig['adminmail']);
            $xoopsMailer->assign('SITEURL', XOOPS_URL."/");
            $member_handler =& xoops_gethandler('member');
            $xoopsMailer->setToGroups($member_handler->getGroup($xoopsConfigUser['activation_group']));
            $xoopsMailer->setFromEmail($xoopsConfig['adminmail']);
            $xoopsMailer->setFromName($xoopsConfig['sitename']);
            $xoopsMailer->setSubject(sprintf(_MD_XOONIPS_ACTIVATE_KEY_SUBJECT,$uname));
            if ( !$xoopsMailer->send() ) {
                echo _MD_XOONIPS_ACTIVATE_BY_ADMIN_MAILNG;
            } else {
                if( $is_certify_auto ){
                    // XOOPS : by admin, XooNIps : auto
                    echo _MD_XOONIPS_ACTIVATE_BY_ADMIN_CERTIFY_AUTO;
                }else{
                    // XOOPS : by admin, XooNIps : moderator
                    echo _MD_XOONIPS_ACTIVATE_BY_ADMIN_CERTIFY_MANUAL;
                }
            }
        }
        // send e-mail to XOOPS Admin
        if ($xoopsConfigUser['new_user_notify'] == 1 && !empty($xoopsConfigUser['new_user_notify_group'])) {
            $xoopsMailer =& getMailer();
            $xoopsMailer->useMail();
            $member_handler =& xoops_gethandler('member');
            $xoopsMailer->setToGroups($member_handler->getGroup($xoopsConfigUser['new_user_notify_group']));
            $xoopsMailer->setFromEmail($xoopsConfig['adminmail']);
            $xoopsMailer->setFromName($xoopsConfig['sitename']);
            $xoopsMailer->setSubject(sprintf(_US_NEWUSERREGAT,$xoopsConfig['sitename']));
            $xoopsMailer->setBody(sprintf(_US_HASJUSTREG, $uname));
            $xoopsMailer->send();
        }
    } else {
        echo "<span style='color:#ff0000; font-weight:bold;'>$stop</span>";
        include 'include/registerform.php';
        $reg_form->display();
    }
    include XOOPS_ROOT_PATH.'/footer.php';
    break;
case 'register':
default:
    include XOOPS_ROOT_PATH.'/header.php';
    echo "<br />" . _MD_XOONIPS_ACCOUNT_EXPLAIN_REQUIRED_MARK. "<br />\n";
    include 'include/registerform.php';
    $reg_form->display();
    include XOOPS_ROOT_PATH.'/footer.php';
    break;
}
?>
