<?php
// $Revision: 1.7.6.3 $
//  ------------------------------------------------------------------------ //
//  XooNIps - Neuroinformatics Base Platform System                          //
//  Copyright (C) 2005-2007 RIKEN, Japan All rights reserved.                //
//  http://xoonips.sourceforge.jp/                                           //
//  ------------------------------------------------------------------------ //
//  This program is free software; you can redistribute it and/or modify     //
//  it under the terms of the GNU General Public License as published by     //
//  the Free Software Foundation; either version 2 of the License, or        //
//  (at your option) any later version.                                      //
//                                                                           //
//  You may not change or alter any portion of this comment or credits       //
//  of supporting developers from this source code or any supporting         //
//  source code which is considered copyrighted (c) material of the          //
//  original comment or credit authors.                                      //
//                                                                           //
//  This program is distributed in the hope that it will be useful,          //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of           //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            //
//  GNU General Public License for more details.                             //
//                                                                           //
//  You should have received a copy of the GNU General Public License        //
//  along with this program; if not, write to the Free Software              //
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA //
//  ------------------------------------------------------------------------ //

$xoopsOption['pagetype'] = 'user';
include '../../mainfile.php';
include_once XOOPS_ROOT_PATH.'/class/module.textsanitizer.php';

include_once XOOPS_ROOT_PATH . '/modules/system/constants.php';
include_once 'include/lib.php';

$config_handler =& xoops_gethandler('config');
$xoopsConfigUser =& $config_handler->getConfigsByCat(XOOPS_CONF_USER);

// configuration for XooNIps
require_once 'condefs.php';
require_once 'include/create_session.php';
xnp_load_init_create_session();
$xnpsid = $_SESSION['XNPSID'];

$xoopsOption['template_main'] = 'xoonips_userlist.html';
include './header.php';

$uid = 0;
if ( isset( $_GET['uid'] ) )
	$uid = intval($_GET['uid']);

if ($uid <= 0) {
    if ( $xoopsUser ) {
        $uid=$xoopsUser->getVar('uid');
    }else{
        // request login and back here.
    	redirect_header('user.php', 3, _NOPERM );
    	exit();
    }
}

if( intval( $_SESSION['xoopsUserId'] ) == $uid ){
	$piedit = 1;
	$xoopsTpl->assign('piedit', $piedit);
}

// get variables from database
global $xoopsDB, $xoopsTpl;
$myts = & MyTextSanitizer::getInstance();
$sql  = "select i1.uid, i1.name, i1.uname, i2.posi_id, i2.posi_title ";
$sql .= "from ".$xoopsDB->prefix("users")." as i1, ".$xoopsDB->prefix("xoonips_positions")." as i2, ".$xoopsDB->prefix("xoonips_users")." as i3 ";
$sql .= "where i2.posi_id=i3.posi and not (i2.posi_order < 0) and i1.uid=i3.uid and not (i3.user_order < 0) and i3.activate=1 ";
$sql .= "order by i2.posi_order ASC, i3.user_order ASC, i1.uid ASC";
$result = $xoopsDB->query( $sql );


// show XOOPS users
$tmp = '<table border="0">';
$otitle = '';
while ( $myrow = $xoopsDB->fetchArray($result) ) {

	 if( $otitle != $myrow['posi_id'] ) {
	 		$ptitle = $myts -> htmlSpecialChars( $myrow['posi_title'] );
			$tmp .= "<tr><td>&nbsp;</td></tr><tr><th>".$ptitle."</th></tr>";
		}
		$ruid = intval( $myrow['uid'] );
		if( strlen( trim ( $myrow['name'] ) ) !== 0 ){
			$rname = $myts -> htmlSpecialChars( $myrow['name'] );
			$tmp .= "<tr><td>&nbsp;&nbsp;&nbsp;&nbsp;<a href=\"showusers.php?uid=".$ruid."\">".$rname."</a></td></tr>";
		} else {
			$rname = $myts -> htmlSpecialChars( $myrow['uname'] );
			$tmp .= "<tr><td>&nbsp;&nbsp;&nbsp;&nbsp;<a href=\"showusers.php?uid=".$ruid."\">".$rname."</a></td></tr>";
		}
		$otitle = intval( $myrow['posi_id'] );
	}

$tmp .= "</table>";
$xoopsTpl -> assign('html', $tmp);


include XOOPS_ROOT_PATH.'/footer.php';
?>
